;******************
;Version 1.1 7th November 2004
;******************


;A suite of programs to work with McNeals DOSLib
(defun DOSLIBAlert (message title button icon / return)
	(setq return nil)
	
	;support McNeals DOSLib version for AutoCAD 2000
	;checking if loaded
	(if (= (LoadDOSLib) T);LoadDOSLib returns T if DOSLib is loaded
		(setq return (dos_msgbox message title button icon));Use the message box in DOSLib
		(alert message);Use the standard AutoCAD alert box
		)
	
	return
	)


(defun LoadDOSLib ( / ass flag i supported version)
	;setting flag, nil represents library not loaded
	(setq flag nil)
	
	;setting list of associations
	(setq ass (list
		(list 15 "doslib6.arx");libraries that support AutoCAD 2002
		(list 16 "doslib2004.arx");libraries that support AutoCAD 2005
		))
	
	;checks whether DOSLib is already loaded and if not then, loads the library for release 2000 and above
	(if (AND
		(NOT (member '"doslib13.arx" (arx)))
		(NOT (member '"doslib14.arx" (arx)))
		(NOT (member '"doslib2k.arx" (arx)))
		(NOT (member '"doslib6.arx" (arx)))
		(NOT (member '"doslib2004.arx" (arx)))
		(NOT (member '"doslib15.arx" (arx)))
		(NOT (member '"doslib16.arx" (arx)))
		)
		(progn
			;so DOSlib has not been loaded
			;retrieving the version of autoCAD being used
			(setq version (atoi (substr (getvar "acadver") 1 2)))
			;cycling through those of the DOSLibs supported for AutoCAD version
			;retrieving those of the DOSLib libraries for AutoCAD version
			(setq supported (cdr (assoc version ass)))
			(print supported)
			;setting the flag to nil, flag will be set to true if one of the libraries can be loaded
			(setq flag nil i 0)
			(while (AND (< i (length supported)) (= flag nil))
				;trying to load the supported library
				;checking to see if the library is available and if it is trying to load it
;				(prompt "\nTrying to load ") (princ (nth i supported))
				(prompt (strcat "\nTrying to load" (nth i supported)))
				(if (AND (NOT (member (nth i supported) (arx))) (/= (findfile (nth i supported)) nil))
					(arxload (findfile (nth i supported)));loading library if available
					)
				;checking whether library is loaded, sets flag to true is library is loaded
				(if (NOT (= (member (nth i supported) (arx)) nil))
					(progn
;						(prompt "\nLibrary ") (princ (nth i supported)) (princ " loaded.")
						(setq flag T)
						)
					(progn
;						(prompt "\nLibrary ") (princ (nth i supported)) (princ " NOT loaded.")
						(setq flag nil)
						)
					)
;				(print flag)
				;incrementing the counter
				(setq i (1+ i))
				)
			;This, first checks the version of AutoCAD in use.
			;It then checks to see if that version of Doslib is loaded.
			;If it is not, it searches the AutoCAD search path for the
			;relevant version, and then loads it.
			)
		(setq flag T)
		;library loaded, resetting flag
		)
	
	flag
	)


